SystemOrganization addCategory: #RatPack!

HttpAdaptor subclass: #RPHttpAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RatPack'!

!RPHttpAdaptor methodsFor: 'processing' stamp: 'tfel 1/31/2012 19:09'!
beginConversation
	| response request count limit continue |
	"copied from HttpAdaptor>>beginConversation"

	count := 0.
	continue := true.
	limit := self maxKeepAliveRequests.
	[[
		[request := self readRequest] on: Error do: [ :ex | continue := false].
		continue ifTrue:
			[[Bindings clamp:
				[response := self dispatchRequest: request.
				self addConnectionHeaders: response request: request count: count.
				(self writeResponse: response for: request) ifFalse: [^self].
				self doPostProcessingFor: request response: response].
			count := count + 1.
			continue := response isPersistent and: [count < limit]] fork].
		continue.
	] whileTrue]
		ensure: [self destroy]! !

HttpService subclass: #RPApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RatPack'!

!RPApplication class methodsFor: 'instance creation' stamp: 'tfel 1/31/2012 18:25'!
debug

	^ self runIn: #debug on: 4567 named: 'RatPack'! !

!RPApplication class methodsFor: 'constants' stamp: 'tfel 1/31/2012 14:00'!
errorPage

	^ '<!!DOCTYPE html>
<html>
<head>
<style type="text/css">
body \{ text-align:center;font-family:helvetica,arial;font-size:22px;
color:#888;margin:20px\}
#c \{margin:0 auto;width:500px;text-align:left\}
</style>
</head>
<body>
<h2>{1}: {2}</h2>
<div id="c">
<pre>
{3}
</pre>
</div>
</body>
</html>'
! !

!RPApplication class methodsFor: 'constants' stamp: 'tfel 1/31/2012 18:01'!
notFoundPage

	 ^ '<!!DOCTYPE html>
<html>
<head>
<style type="text/css">
body \{ text-align:center;font-family:helvetica,arial;font-size:22px;
color:#888;margin:20px\}
#c \{margin:0 auto;width:500px;text-align:left\}
.methodName \{ color: black; \}
.pragmaKey \{ color: green; \}
.string \{ color: purple; \}
.return \{ color: darkRed; \}
</style>
</head>
<body>
<h2>The Rat Pack doesn&rsquo;t play in this joint.</h2>
<div id="c">
Try this:
<pre>
<span class="methodName">handleRequestFor{3}</span>
  &lt;<span class="pragmaKey">{1}</span>: <span class="string">''{2}''</span>&gt;
  <span class="return">^</span> <span class="string">''Hello World''</span>
</pre>
</div>
<div id="c">
Or that:
<pre>
<span class="methodName">handleRequestFor{3}: argument</span>
  &lt;<span class="pragmaKey">{1}</span>: <span class="string">''{4}''</span>&gt;
  <span class="return">^</span> <span class="string">''Hello ''</span>, argument
</pre>
</div>
</body>
</html>'
! !

!RPApplication class methodsFor: 'constants' stamp: 'tfel 1/31/2012 13:43'!
requestKey

	^ #rpRequest! !

!RPApplication class methodsFor: 'constants' stamp: 'tfel 1/31/2012 13:43'!
responseKey

	^ #rpResponse! !

!RPApplication class methodsFor: 'instance creation' stamp: 'tfel 1/31/2012 18:24'!
run

	^ self runIn: #deployment on: 4567 named: 'RatPack'! !

!RPApplication class methodsFor: 'instance creation' stamp: 'tfel 1/31/2012 18:24'!
runIn: mode on: aPort named: aString
	| service |
	service := self on: aPort named: aString.
	^ service
		mode: mode;
		onRequestDo: [:httpRequest | service processRequest: httpRequest];
		start;
		yourself
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:15'!
attachment: aFilename

	| attachmentHeader |
	attachmentHeader := 'attachment; filename="', (FileDirectory localNameFor: aFilename), '"'.
	self response headers: {'Content-Disposition' -> attachmentHeader}.
	(FileDirectory default mimeTypesFor: aFilename) ifNotNilDo: [:mimeTypes |
		self response headers: {'Content-Type' -> mimeTypes first}].
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:00'!
body
	
	^ self response contents
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:03'!
body: aStringOrStream

	self response contents: (aStringOrStream isStream
		ifTrue: [aStringOrStream]
		ifFalse: [ReadStream on: aStringOrStream]).! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 11:56'!
contentType

	^ (self threadLocal: self class responseKey) contentType! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:04'!
contentType: aString

	^ self response contentType: aString! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:02'!
headers

	^ self response fields! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:02'!
headers: aDictionary

	self response fields addAll: aDictionary.! !

!RPApplication methodsFor: 'actions' stamp: 'tfel 1/31/2012 18:01'!
notFound
	| methodName allButLastPath pathParts |
	self contentType: 'text/html'.
	self status: 404.
	pathParts := self request pathParts ifNil: [#('')].
	methodName := pathParts inject: '' into: [:acc :next | acc, next capitalized].
	allButLastPath := (pathParts allButLast inject: '' into: [:acc :next | acc, '/', next]), '/%'.
	(self request url endsWith: '/') ifTrue: [allButLastPath := allButLastPath, '/'].
	^ self class notFoundPage format: { self request method asLowercase.
										 self request url.
										 methodName .
										 allButLastPath }! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 12:20'!
params

	^ self request fields! !

!RPApplication methodsFor: 'routing' stamp: 'tfel 1/31/2012 19:01'!
processRequest: aHttpRequest
	| response |
	Processor activeProcess
		environmentAt: self class requestKey put: aHttpRequest;
		environmentAt: self class responseKey put: HttpResponse new.
	response := [self route: aHttpRequest] on: Error do: [:e | self serverError: e].
	response isString ifFalse: [response := ''].
	(self status = 404 and: [response isEmpty]) ifTrue: [response := self notFound].
	self body: response.
	^ self response
! !

!RPApplication methodsFor: 'actions' stamp: 'tfel 1/31/2012 12:17'!
redirectBack

	self redirectTo: self request referer.! !

!RPApplication methodsFor: 'actions' stamp: 'tfel 1/31/2012 12:18'!
redirectTo: aString

	self response redirectTo: aString.
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 11:40'!
request
	
	^ self threadLocal: self class requestKey
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 11:59'!
response
	
	^ self threadLocal: self class responseKey
! !

!RPApplication methodsFor: 'routing' stamp: 'tfel 1/31/2012 21:09'!
route: aHttpRequest
	| arguments result method |
	method := aHttpRequest method asLowercase asSymbol asMutator.
	arguments := (((Pragma allNamed: method from: self class to: RPApplication)
					collect: [:pragma || rx |
						rx := RxMatcher forString: ((pragma argumentAt: 1)
														copyReplaceAll: '%'
														with: '([^/]+)').
						(rx matches: aHttpRequest url)
							ifTrue: [pragma -> rx subexpressions allButFirst]
							ifFalse: [nil]])
					reject: [:assoc | assoc isNil])
					sortBy: [:a :b | a value size < b value size].
	arguments ifEmpty: [self status: 404. ^ ''].
	result := arguments first key method
				valueWithReceiver: self
				arguments: arguments first value.
	^ result isString ifTrue: [result] ifFalse: [self body]
! !

!RPApplication methodsFor: 'serving' stamp: 'tfel 1/31/2012 19:05'!
serve: aSocket 
	self class current: self.
	RPHttpAdaptor readAndWriteToSocket: aSocket service: self.! !

!RPApplication methodsFor: 'actions' stamp: 'tfel 1/31/2012 17:30'!
serverError: anException

	self contentType: 'text/html'.
	self status: 500.
	self isDebugMode ifTrue: [anException signal].
	^ self class errorPage format: { anException class name asString asHtml .
									 anException messageText asString asHtml .
									 anException signalerContext longStack asHtml }
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 11:57'!
status
	
	^ (self threadLocal: self class responseKey) statusCode asInteger
! !

!RPApplication methodsFor: 'accessing' stamp: 'tfel 1/31/2012 11:59'!
status: aSymbolOrInteger

	self response status: (aSymbolOrInteger isSymbol
		ifTrue: [aSymbolOrInteger]
		ifFalse: [HttpResponse statusSymbolFor: aSymbolOrInteger]).
! !

!RPApplication methodsFor: 'private' stamp: 'tfel 1/31/2012 13:56'!
threadLocal: aSymbol
	
	^ Processor activeProcess environmentAt: aSymbol ifAbsent: []
! !
